#ifndef MCSERPAP_H_
#define MCSERPAP_H_

#include "mcsEnsemble.h"
#include "mcsOptions.h"
//#include <boost/weak_ptr.hpp>
#include <map>
#include <algorithm>
#include<iostream>
//#include <LEDA/geo/d2_dictionary.h>
//#include <kdtree++/kdtree.hpp>
//#include <functional>

class mcsERPAP
{
    public:
    	
    					mcsERPAP(	const	Molecule&       myMol1,
    								const 	Molecule&       myMol2,
    								const 	PatternPairMap& myPatterns,
    										PatternPairMap& myERPAP,
    										int&		    mySize,
    								const	mcsOptions&     myOptions)
    	                                   
    	                                   :matchedPatterns(myERPAP),
    	                                	mol1(myMol1),mol2(myMol2),
    	                                    patterns(myPatterns),
    	                                    matchedSize(mySize),
    	                                    minPatternSize(myOptions.minPatternSize) {};
    	                                    
        virtual 		~mcsERPAP();
        
        		void    calculateERPAP();
    		
	private:
		
		enum 		KeyTypeE	{BEGIN_KEY, END_KEY };
        struct      HoleKeyS;
        
       
//*********************************************************************************************
// kd-tree code
//*********************************************************************************************        
/*
       
        struct EPMTreeKeyS
                {     
        	
        	
        	KeyTypeE						keyType;
        			PatternPairMap::SelfValuePTR    pattern;
                    int                             score;
                    
                    int  d[2];
                    inline int operator[](size_t const N) const { return d[N]; }
                    
                };
        typedef     EPMTreeKeyS                             EPMTreeKey;
        typedef     EPMTreeKey*                             EPMTreeKeyPTR;
        
        friend bool operator==(EPMTreeKey const& A,EPMTreeKey const& B) {
                                                   return A.d[0] == B.d[0] && A.d[1] == B.d[1];}
        
        friend double tac( EPMTreeKeyPTR t, int k ) { return (*t)[k]; }
        
        typedef KDTree::KDTree<2, EPMTreeKeyPTR, std::pointer_to_binary_function<EPMTreeKeyPTR,int,double> > tree_type;

                
      
      
       
       leda::d2_dictionary<int,int,EPMTreeKeyPTR> EPM_tree; 
       
  */     
 /*      friend bool operator==(PatternTreeKey const& A, PatternTreeKey const& B) 
       {
    	   return A.d[0] == B.d[0] && A.d[1] == B.d[1];
    	   if (keyType == BEGIN_KEY)
    	   {
    		   return bounds.first.first == bounds.
    	   }
       }*/

        
       

  
  //      typedef KDTree::KDTree<2, PatternTreeKey, std::pointer_to_binary_function<PatternTreeKey,int,double> > pattern_tree_type;

        
  //      pattern_tree_type 	patternTree;
                
//*********************************************************************************************
        
        
        struct HoleKeyS
        {
        	PatternPairMap::SelfValuePTR    pattern;
            intPPair                        bounds;
        };
        
        typedef     HoleKeyS                            HoleKey;
        typedef     HoleKey*                            HoleKeyPTR;
        typedef     multimap<int,HoleKeyPTR>            HoleOrderingMapTYPE;
        typedef     HoleOrderingMapTYPE::const_iterator HoleMapCITER;
           
  
    void    preProcessing				();
    void 	preProcessingTree			();
    void    calculateHoles				();
//    void    calculatePatternBoundaries	(const boost::shared_ptr<PatternPair>& myPair);
    void    calculatePatternBoundaries	(PatternPair* myPair);
    void 	calculateTraceback			(const int i,const int j,const int k,const int l,vector < vector<int> > holeVec);
    int 	D_rec						(const int& i,const  int& j,const int& k,const int& l,vector < vector<int> >& D_h);
    int 	max3						(int& a, int& b, int& c);
    
            

    		vector< vector<PatternPairMap::SelfValuePTR> >	EPM_Table;
            PatternPairMap&					matchedPatterns;
            
            HoleOrderingMapTYPE     		holeOrdering;
            
            
      const Molecule&               		mol1,mol2;
      const PatternPairMap&         		patterns;
      		int& 							matchedSize;
      const	int                     		minPatternSize;
      		
};
#endif /*MCSERPAP_H_*/
