#ifndef MCSOPTIONS_H_
#define MCSOPTIONS_H_

#include <vector>
#include <string>

class mcsOptions
{
public:
	mcsOptions()
		{
			minPatternSize 				= 2;
			maxPatternNumber 			= 0;
			writeXML   					= false;
			writeAllEPMsXML   			= false;
			calcERPAP					= false;
			clustering 					= false;
			alignColor					= false;
  			distanceThresholdClustering = 5;
  			distanceEqualThreshold 	    = 5;
  			clusterSaveCounter 			= 1;
  			CLUSTER_METHODE				= CLUSTER_MAX;
  			DISTANCE_METHODE			= DIST_SEQUENCE;
		};
		
	mcsOptions(const mcsOptions& myOptions): cmdLineValues(myOptions.cmdLineValues),
										     minPatternSize(myOptions.minPatternSize),
										     maxPatternNumber(myOptions.maxPatternNumber),
										     distanceThresholdClustering(myOptions.distanceThresholdClustering),
										     distanceEqualThreshold(myOptions.distanceEqualThreshold),
										     clusterSaveCounter(myOptions.clusterSaveCounter),
										     writeXML(myOptions.writeXML),
										     writeAllEPMsXML(myOptions.writeAllEPMsXML),
										     clustering(myOptions.clustering),
										     calcERPAP(myOptions.calcERPAP),
										     alignColor(myOptions.alignColor),
										     CLUSTER_METHODE(myOptions.CLUSTER_METHODE),
										     DISTANCE_METHODE(myOptions.DISTANCE_METHODE) {};
										     
	virtual ~mcsOptions();
	
		enum CLUSTER_METHODE_Options	{ CLUSTER_MAX, CLUSTER_ALL };
		enum DISTANCE_METHODE_Options { DIST_SEQUENCE, DIST_EQUAL, DIST_SHORTESTPATH };
	
		std::vector<std::string>	 	cmdLineValues;
		
		std::string				mol1Id;
		std::string 			mol2Id;
		
		int					minPatternSize;
		int					maxPatternNumber;
  		int    				distanceThresholdClustering;
  		int 				distanceEqualThreshold; 	
  		int    				clusterSaveCounter;
  		bool   				writeXML;
  		bool				writeAllEPMsXML;
  		bool				clustering;
  		bool				calcERPAP;
  		bool				alignColor;
		
		CLUSTER_METHODE_Options	CLUSTER_METHODE;
		DISTANCE_METHODE_Options DISTANCE_METHODE;
};

#endif /*MCSOPTIONS_H_*/
