#ifndef MCS_XML_IO_H_
#define MCS_XML_IO_H_

#include"xercesc/util/PlatformUtils.hpp"
#include<xercesc/util/XMLString.hpp>
#include<xercesc/dom/DOM.hpp>
#include<xercesc/dom/DOMConfiguration.hpp>
#include<xercesc/dom/DOMTreeWalker.hpp>
#include<xercesc/dom/DOMNodeFilter.hpp>
#include<xercesc/framework/StdOutFormatTarget.hpp>
#include<xercesc/framework/LocalFileFormatTarget.hpp>
#include<locale.h>
#include<string>
#include<iostream>
#include<iterator>
#include <sstream>
#include"Util_String.h"
#include"mcsEnsemble.h"
#include"DATA_Patterns.h"


using namespace std;
XERCES_CPP_NAMESPACE_USE

class mcs_xml_io
{

   public:
   
               mcs_xml_io(string mydoctype);
               mcs_xml_io(mcs_xml_io& toCopy);
      virtual  ~mcs_xml_io();
      void     xml_append_molecule(Molecule& myMol);
      //void     xml_append_patterns(PatternMap& myPMap);
      void     xml_append_patterns(PatternPairMap& myPMap);
      void     xml_filewriter(string xml_filename);
   
   private:
   
	  DOMDocument *rootdoc;
	  string 	    doctype;					// "RNAPatterns"
     
	  void 		xml_createrootdoc(string mydoctype);
	  void 		xml_init();
	  void 		xml_terminate();
	

};

class XStr
{
public :
    // -----------------------------------------------------------------------
    //  Constructors and Destructor
    // -----------------------------------------------------------------------
    XStr(const char* const toTranscode)
    {
        // Call the private transcoding method
        fUnicodeForm = XMLString::transcode(toTranscode);
    }

    ~XStr()
    {
        XMLString::release(&fUnicodeForm);
    }


    // -----------------------------------------------------------------------
    //  Getter methods
    // -----------------------------------------------------------------------
    const XMLCh* unicodeForm() const
    {
        return fUnicodeForm;
    }

private :
    // -----------------------------------------------------------------------
    //  Private data members
    //
    //  fUnicodeForm
    //      This is the Unicode XMLCh format of the string.
    // -----------------------------------------------------------------------
    XMLCh*   fUnicodeForm;
};

#define X(str) XStr(str).unicodeForm()

#endif /*MCS_XML_IO_H_*/
